#pragma semicolon 1
#include <sourcemod>
#include <adminmenu>
#include <sdktools>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name = "Player Weapon Blocker",
	author = "KOROVKA", // Plugin by KOROVKA
	description = "Block access to weapons for the player (Temporarily or permanently)",
	version = "1.2.0",
	url = ""
};

new bool:g_StatusMenu[MAXPLAYERS+1];
new Handle:g_hDbLocal;
new g_cTime[MAXPLAYERS+1];
new Handle:hTopMenu;
new g_TargetUserId[MAXPLAYERS+1];
new Handle:TimerCheckUnBan[MAXPLAYERS+1];

static String:Color1[10];
static String:Color2[10];
static String:Color3[10];
static String:Color4[10];

String:NumToName(num, type)
{
	static String:TimeNames[][][] = { {"день", "дня", "дней"}, {"час", "часа", "часов"}, {"минута", "минуты", "минут"}, {"секунда", "секунды", "секунд"} };
	
	new String:buffer[128];
	switch(num)
	{
		case 0:		{}
        case 1:		FormatEx(buffer, 128, "1 %s ", TimeNames[type][0]);
        case 2,3,4: FormatEx(buffer, 128, "%i %s ", num, TimeNames[type][1]);
        default:
        {
			if(num < 21) FormatEx(buffer, 128, "%i %s ", num, TimeNames[type][2]);
			else
			{
				switch(num % 10)
				{
					case 1:		FormatEx(buffer, 128, "%i %s ", num, TimeNames[type][0]);
					case 2,3,4: FormatEx(buffer, 128, "%i %s ", num, TimeNames[type][1]);
					default:	FormatEx(buffer, 128, "%i %s ", num, TimeNames[type][2]);
				}
			}
		}
	}
	return buffer;
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	CreateNative("IsClientInWeaponBlock", Native_IsClientInWeaponBlock);
	CreateNative("GetClientTimeWeaponBlock", Native_GetClientTimeWeaponBlock);
	CreateNative("SetClientTimeWeaponBlock", Native_SetClientTimeWeaponBlock);
}

public Native_IsClientInWeaponBlock(Handle:plugin, numParams)
{
	new client = GetNativeCell(1);
	if(g_cTime[client] == 0 || g_cTime[client] > GetTime()) return true;
	return false;
}

public Native_GetClientTimeWeaponBlock(Handle:plugin, numParams)
{
	return g_cTime[GetNativeCell(1)];
}

public Native_SetClientTimeWeaponBlock(Handle:plugin, numParams) DB_InsertPlayer(GetNativeCell(1), GetNativeCell(2));

public OnPluginStart()
{
	switch(GetEngineVersion()) 
	{ 
		case Engine_CSS: Color1 = "\x07FFFFFF", Color2 = "\x07FFF700", Color3 = "\x07FF0000", Color4 = "\x0700BFFF"; // Белый, желтый, красный, голубой
		case Engine_CSGO: Color1 = "\x04", Color2 = "\x01", Color3 = "\x02", Color4 = "\x06";
		default: Color1 = "\x04", Color2 = "\x01", Color3 = "\x02", Color4 = "\x04";
	}
	
	new Handle:topmenu;
	if(LibraryExists("adminmenu") && (topmenu = GetAdminTopMenu()) != INVALID_HANDLE) OnAdminMenuReady(topmenu);
	
	decl String:sError[156];
	g_hDbLocal = SQLite_UseDatabase("player_weapon_blocker by.korovka", sError, 156);
	SQL_FastQuery(g_hDbLocal, "CREATE TABLE IF NOT EXISTS chat (steamid varchar(20) PRIMARY KEY, unix int(10));");
	if(g_hDbLocal == INVALID_HANDLE || sError[0]) LogError("Не удалось установить соединение с БД! \n%s", sError);
}

public Action:WeaponCanUse(client, weapons) return Plugin_Handled;

public Action:WeaponDrop(client, weapons) return Plugin_Handled;

public PreThink(client)
{
	new buttons = GetClientButtons(client);
	if(buttons & IN_ATTACK)
	{
		buttons &= ~IN_ATTACK;
		SetEntProp(client, Prop_Data, "m_nButtons", buttons);
	}
	if(buttons & IN_ATTACK2)
	{
		buttons &= ~IN_ATTACK2;
		SetEntProp(client, Prop_Data, "m_nButtons", buttons);
	}
}

public OnAdminMenuReady(Handle:topmenu) 
{
	if(topmenu != hTopMenu) 
	{
		hTopMenu = topmenu;
		new TopMenuObject:player_commands = FindTopMenuCategory(hTopMenu, ADMINMENU_PLAYERCOMMANDS);
		if(player_commands != INVALID_TOPMENUOBJECT) AddToTopMenu(hTopMenu, "sm_player_weapon_blocker", TopMenuObject_Item, AdminMenu_PlayerWeaponBlocker, player_commands, "sm_player_weapon_blocker", ADMFLAG_SLAY);
	}
}

public AdminMenu_PlayerWeaponBlocker(Handle:topmenu, TopMenuAction:action, TopMenuObject:object_id, param, String:buffer[], maxlength)
{
	if(action == TopMenuAction_DisplayOption) FormatEx(buffer, maxlength, "Управление оружием игрока");
	else if(action == TopMenuAction_SelectOption)
	{
		new Handle:menu = CreateMenu(MenuHandler_CommandsList);
		SetMenuTitle(menu, "Управление оружием игрока:");
		SetMenuExitBackButton(menu, true);
		AddMenuItem(menu, "0", "Заблокировать оружие игроку");
		AddMenuItem(menu, "1", "Разблокировать оружие игроку");
		
		DisplayMenu(menu, param, MENU_TIME_FOREVER);
	}
}

public MenuHandler_CommandsList(Handle:menu, MenuAction:action, param1, param2)
{
	switch(action)
	{
		case MenuAction_Select: DisplayPlayerWeaponBlockerMenu(param1, (param2 == 0));
		case MenuAction_Cancel: 
		{
			CloseHandle(menu);
			if(param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE) DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
}

DisplayPlayerWeaponBlockerMenu(client, bool:status)
{
	g_StatusMenu[client] = status;
	
	new Handle:menu = CreateMenu(MenuHandler_PlayersList);

	SetMenuTitle(menu, "%s оружие игроку:", status ? "Заблокировать":"Разблокировать");
	SetMenuExitBackButton(menu, true);

	AddTargetsToMenu2(menu, client, COMMAND_FILTER_NO_BOTS|COMMAND_FILTER_CONNECTED);

	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_PlayersList(Handle:menu, MenuAction:action, param1, param2) 
{
	switch(action)
	{
		case MenuAction_Select:
		{
			if(param1 > 0)
			{
				decl String:info[10];
				new userid, target;

				GetMenuItem(menu, param2, info, 10);
				userid = StringToInt(info);
			
				if((target = GetClientOfUserId(userid)) == 0)
				{
					DisplayPlayerWeaponBlockerMenu(param1, g_StatusMenu[param1]);
					PrintToChat(param1, "%s[Player Weapon Blocker] %sИгрок вышел!", Color1, Color2);
				}
				else if(!CanUserTarget(param1, target)) PrintToChat(param1, "%s[Player Weapon Blocker] %sИгрок не доступен!", Color1, Color2);
				else
				{
					g_TargetUserId[param1] = userid;
				
					if(g_StatusMenu[param1]) DisplayPlayerWeaponBlockerTimeMenu(param1, target);
					else if(g_cTime[target] != 1)
					{
						for (new i = 1; i <= MaxClients; i++)
						{
							if(IsClientInGame(i) && GetUserAdmin(i) != INVALID_ADMIN_ID && i != param1) PrintToChat(i, "%s[Player Weapon Blocker] %sАдминистратор %s%N%s разблокировал доступ к оружию игроку %s%N", Color1, Color2, Color3, param1, Color2, Color3, target);
						}
						
						PrintToChat(param1, "%s[Player Weapon Blocker] %sДоступ к оружию игроку %s%N %sбыл успешно разблокирован!", Color1, Color2, Color3, target, Color2);
						PrintToChat(target, "%s[Player Weapon Blocker] %sВам разблокировали доступ к оружию!", Color1, Color2);
						DB_InsertPlayer(target, 1);
					}
					else
					{
						DisplayPlayerWeaponBlockerMenu(param1, g_StatusMenu[param1]);
						PrintToChat(param1, "%s[Player Weapon Blocker] %sИгрок %s%N %sне имеет блокировки доступа к оружию!", Color1, Color2, Color3, target, Color2);
					}
				}
			}
		}
		case MenuAction_Cancel: 
		{
			CloseHandle(menu);
			if(param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE) DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
}

DisplayPlayerWeaponBlockerTimeMenu(client, target)
{
	new Handle:menu = CreateMenu(MenuHandler_TimeList);

	SetMenuTitle(menu, "Выдать блокировку оружия: %N", target);
	SetMenuExitBackButton(menu, true);

	AddMenuItem(menu, "0", "Навсегда");
	AddMenuItem(menu, "10", "10 минут");
	AddMenuItem(menu, "30", "30 минут");
	AddMenuItem(menu, "60", "1 час");
	AddMenuItem(menu, "240", "4 часа");
	AddMenuItem(menu, "1440", "1 день");
	AddMenuItem(menu, "10080", "1 неделя");

	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_TimeList(Handle:menu, MenuAction:action, param1, param2)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			if(param1 > 0)
			{
				decl String:info[10];

				GetMenuItem(menu, param2, info, 10);
				new time = StringToInt(info);
				new target;

				if((target = GetClientOfUserId(g_TargetUserId[param1])) == 0) PrintToChat(param1, "%s[Player Weapon Blocker] %sИгрок вышел!", Color1, Color2);
				else if(!CanUserTarget(param1, target)) PrintToChat(param1, "%s[Player Weapon Blocker] %sИгрок не доступен!", Color1, Color2);
				else
				{
					for (new i = 1; i <= MaxClients; i++)
					{
						if(IsClientInGame(i) && GetUserAdmin(i) != INVALID_ADMIN_ID && i != param1)
						{
							if(time > 0) PrintToChat(i, "%s[Player Weapon Blocker] %sАдминистратор %s%N%s заблокировал доступ к оружию игроку %s%N %s(На %d минут)", Color1, Color2, Color3, param1, Color2, Color3, target, Color4, time);
							else PrintToChat(i, "%s[Player Weapon Blocker] %sАдминистратор %s%N%s заблокировал доступ к оружию игроку %s%N %s(Навсегда)", Color1, Color2, Color3, param1, Color2, Color3, target, Color4);
						}
					}
					
					if(time > 0) PrintToChat(param1, "%s[Player Weapon Blocker] %sДоступ к оружию игроку %s%N %sбыл успешно заблокирован! %s(На %d минут)", Color1, Color2, Color3, target, Color2, Color4, time);
					else PrintToChat(param1, "%s[Player Weapon Blocker] %sДоступ к оружию игроку %s%N %sбыл успешно заблокирован! %s(Навсегда)", Color1, Color2, Color3, target, Color2, Color4);
				
					if(time > 0) PrintToChat(target, "%s[Player Weapon Blocker] %sВам заблокировали доступ к оружию! %s(На %d минут)", Color1, Color2, Color4, time);
					else PrintToChat(target, "%s[Player Weapon Blocker] %sВам заблокировали доступ к оружию! %s(Навсегда)", Color1, Color2, Color4);
				
					DB_InsertPlayer(target, time);
				}
			}
		}
		case MenuAction_Cancel: 
		{
			CloseHandle(menu);
			if(param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE) DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
}

public OnClientPostAdminCheck(client)
{
	g_cTime[client] = 1;
	
	if(!IsFakeClient(client)) DB_SelectPlayer(client);
}

public OnClientDisconnect(client) KillTimerCheckUnBan(client);

DB_SelectPlayer(client)
{
	decl String:sQuery[128], String:sSteamID[20];
	GetClientAuthId(client, AuthId_SteamID64, sSteamID, 20);
	FormatEx(sQuery, 128, "SELECT steamid, unix FROM chat WHERE steamid = '%s';", sSteamID);
	SQL_TQuery(g_hDbLocal, SQL_SelectPlayerCallback, sQuery, client);
}

public SQL_SelectPlayerCallback(Handle:owner, Handle:hndl, const String:error[], any:client)
{
	if(hndl == INVALID_HANDLE || error[0])
	{
		LogError("[Player Weapon Blocker] Не удалось загрузить игроков! \n%s", error);
	}
	else
	{
		if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl))
		{
			new getTime;
			g_cTime[client] = SQL_FetchInt(hndl, 1);
			if(g_cTime[client] == 0 || g_cTime[client] > (getTime = GetTime()))
			{
				SDKHook(client, SDKHook_WeaponCanUse, WeaponCanUse);
				SDKHook(client, SDKHook_WeaponDrop, WeaponDrop);
				SDKHook(client, SDKHook_PreThink, PreThink);
				
				if(!TimerCheckUnBan[client]) TimerCheckUnBan[client] = CreateTimer(300.0, StartTimerCheckUnBan, client, TIMER_REPEAT);
				
				if(g_cTime[client] != 0)
				{
					new time = g_cTime[client] - getTime;
					PrintToChat(client, "%s[Player Weapon Blocker] %sДо разблокировки доступа к оружию осталось: %s%s%s%s%s", Color1, Color2, Color4, NumToName(time/3600/24, 0), NumToName(time/3600%24, 1), NumToName(time/60%60, 2), NumToName(time%60, 3));
				}
			}
			else if(g_cTime[client] != 1)
			{
				DB_InsertPlayer(client, 1);
				KillTimerCheckUnBan(client);
				PrintToChat(client, "%s[Player Weapon Blocker] %sИстекло время блокировки доступа к оружию!", Color1, Color4);
			}
		}
	}
	return 1;
}

public Action:StartTimerCheckUnBan(Handle:timer, any:client) DB_SelectPlayer(client);

public KillTimerCheckUnBan(client)
{
	if(TimerCheckUnBan[client])  
	{
		KillTimer(TimerCheckUnBan[client]);  
		TimerCheckUnBan[client] = INVALID_HANDLE; 
	}
}

DB_InsertPlayer(client, time)
{
	if(time != 1)
	{
		SDKHook(client, SDKHook_WeaponCanUse, WeaponCanUse);
		SDKHook(client, SDKHook_WeaponDrop, WeaponDrop);
		SDKHook(client, SDKHook_PreThink, PreThink);
			
		if(!TimerCheckUnBan[client]) TimerCheckUnBan[client] = CreateTimer(300.0, StartTimerCheckUnBan, client, TIMER_REPEAT);
	
		if(time != 0)
		{
			time = time * 60;
			new getTime;
			
			if(g_cTime[client] < (getTime = GetTime())) g_cTime[client] = getTime;
			
			g_cTime[client] += time;
		}
		else g_cTime[client] = 0;
	}
	else 
	{
		g_cTime[client] = 1;
		
		SDKUnhook(client, SDKHook_WeaponDrop, WeaponDrop);
		SDKUnhook(client, SDKHook_WeaponCanUse, WeaponCanUse);
		SDKUnhook(client, SDKHook_PreThink, PreThink);
		
		KillTimerCheckUnBan(client);
		
		if(GetPlayerWeaponSlot(client, 2) == -1) GivePlayerItem(client, "weapon_knife");
	}
	
	decl String:sQuery[128], String:sSteamID[20];
	GetClientAuthId(client, AuthId_SteamID64, sSteamID, 20);
	
	FormatEx(sQuery, 128, "INSERT OR REPLACE INTO chat (steamid, unix) VALUES('%s', '%d');", sSteamID, g_cTime[client]);
	SQL_FastQuery(g_hDbLocal, sQuery);
}